unit uNomeUsuarioDecorator;

interface

uses
  uDecorator;

type
  { Concrete Decorator }
  TNomeUsuarioDecorator = class(TDecorator)
  private
    function ObterNomeUsuario: string;
  protected
    function ObterDadosExcecao: string; override;
  end;

implementation

uses
  Windows;

function TNomeUsuarioDecorator.ObterDadosExcecao: string;
begin
  // retorna a string dos outros decoradores primeiro
  result := inherited ObterDadosExcecao;

  // adiciona o nome do usurio
  result := result + 'Usurio: ' + ObterNomeUsuario;
end;

function TNomeUsuarioDecorator.ObterNomeUsuario: string;
var
  Size: DWord;
begin
  // retorna o login do usurio do sistema operacional
  Size := 1024;
  SetLength(result, Size);
  GetUserName(PChar(result), Size);
  SetLength(result, Size - 1);
end;

end.
